%define name monitor
%define version 1.0.1
%define release 28

Summary: Monitoring application part of the Nephos framework
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}.tar.gz
Patch1: dummy.patch
Patch2: add-qlayer-monitor-init-script.patch
Patch3: patch5434.patch
Patch4: patch1637.patch_11970
Patch5: add_vm_uuid_to_xen_plugin.patch
Patch6: add_per_cpu_load_stats.patch
Patch7: add_uptime_to_stats.patch
Patch8: linux_monitor_changes_for_new_stats_api.patch
Patch9: xen_stats_changes_for_new_api.patch
Patch10: vmdisk_stats.patch
Patch11: disable-log-consumer.patch
Patch12: log-to-syslog.patch
Patch13: retain-3-days-stats-and-events.patch
Patch14: change-license-to-gplv2.patch
Patch15: disk_stat_format_update.patch
Patch16: monitor-reduce-stats-retain-time-to-30m.patch
Patch17: uuid_disk_names_only.patch
Patch18: fix-undefined-mp-dev.patch
Patch19: change-timestamp-to-milliseconds-from-epoch.patch
Patch20: vm-disk-stats.patch
Patch21: improve-logging.patch
Patch22: fix-vm-cpu-usage-count.patch
Patch23: cpu-usage-ceiling-to-float.patch
Patch24: vm-cpu-util.patch
# End Oracle Patches

License: GPLv2
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{_prefix}
BuildArch: noarch
Requires: python-twisted-core >= 8.0 python-zope-interface PyYAML python-simplejson
Url: http://software.qlayer.com

%description
Monitoring application.

%prep
%setup
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0

%build
python setup.py build

%install
python setup.py install -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES
sed 's|^\(.*\.pyo\)$|%ghost \1|' < INSTALLED_FILES > %{name}-%{version}.files
chmod +x ${RPM_BUILD_ROOT}/etc/init.d/qlayer-monitor

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
    /sbin/chkconfig --add qlayer-monitor
fi

%preun
if [ "$1" = 0 ]; then
    /sbin/service qlayer-monitor stop
    /sbin/chkconfig --del qlayer-monitor
fi

%files -f %{name}-%{version}.files
%defattr(-,root,root)
%doc README LICENSE doc/
%config(noreplace) /etc/monitor/config.yml


%changelog
* Wed Oct 05 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-28 
- return VM cpu utilization
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> 

* Tue Sep 27 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-27 
- change cpu ceiling usage to float instead of int
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Steve Noyes <steve.noyes@oracle.com> [bug 13018645] 

* Mon Sep 26 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-26 
- fix vm cpu usage count
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Steve Noyes <steve.noyes@oracle.com> [bug 13018645] 

* Tue Sep 13 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-25 
- improve logging
  1) Change default_grace to 1 hour from 90 seconds. If a plugin hang, it probably
  hang again on next run. Every 90 seconds kill a hang plugin and restart it is
  too fast. And for some case, it's not hang, it's just takes more than 90
  seconds, e.g., xm list may takes > 90 seconds.
  2) Make plugin never raise exception by: try: ... except: pass. Otherwise, when
  a plugin fails, it will be restarted immediately, which is a dead loop. After
  this change, it will be restarted after the stats_interval (20s).
  3) Clean up some legacy qlayer code (already commented out).
  4) remove some useless log.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 12889843&12889865] 

* Mon Aug 29 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-24 
- fix disk io stats
  New format:
  {"timestamp": 1314380927473, "type": "vmDiskRead", "id":
  "localhost/microcorelinux_x86_hvm", "value":
  {"/share/iso/tinycorelinux/microcore_3.5.1.iso": "0",
  "/dev/mapper/3600601604abd1900ce40868399addc11": "0"}}, {"timestamp":
  1314380927473, "type": "vmDiskWrite", "id": "localhost/microcorelinux_x86_hvm",
  "value": {"/share/iso/tinycorelinux/microcore_3.5.1.iso": "0",
  "/dev/mapper/3600601604abd1900ce40868399addc11": "0"}},
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12869963] 

* Thu Jul 28 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-23 
- change timestamp to milliseconds from epoch
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Steve Noyes <steve.noyes@oracle.com> 

* Mon Jul 25 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-22 
- fix undefined mp_dev
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Cathy Avery <cathy.avery@oracle.com>
  Signed-off-by: Steve Noyes <steve.noyes@oracle.com> [bug 12792762&12792693] 

* Fri Jul 22 2011 Cathy Avery <cathy.avery@oracle.com> - 1.0.1-21 
- Disk stats only show dm uuid names. [bug 12770861] 

* Thu Jul 21 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-20 
- reduce stats retain time from 3 days to 30 minutes.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Steve Noyes <steve.noyes@oracle.com> 

* Mon Jul 18 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-19 
- Set /etc/monitor/config.yml with noreplace

* Mon Jul 11 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-18 
- Change license to GPLv2 [bug 12737215]

* Wed Jul 06 2011 Cathy Avery <cathy.avery@oracle.com> - 1.0.1-17 
-  

* Tue Jul 05 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-16 
- change license to gplv2
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Thu Jun 30 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-15 
- retain 3 days stats and events
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed Jun 29 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-14 
- put monitor log to syslog [bug 12702745&11701424] 

* Wed Jun 29 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 1.0.1-13 
- disable log consumer.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> [bug 11701424] 

* Mon Jun 27 2011 Cathy Avery <cathy.avery@oracle.com> - 1.0.1-12 
- Add vm disk stats. [bug 12655411] 

* Wed Jun 8 2011 Junjie Wei <junjie.wei@oracle.com> - 1.0.1-11
- Add %post and %preun sections into the spec file.

* Fri Apr 15 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-10 
- Xen monitor plugin changes for new stats api. 

* Fri Apr 15 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-9 
- Change monitor output for new stats api. 

* Tue Mar 29 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-8 
- Add uptime to stats output. 

* Mon Mar 28 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-7 
-  

* Tue Jan 18 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-6
- Add exec flags to /etc/init.d/qlayer-monitor
 
* Mon Jan 10 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-5 
- Make sure the xen plugin collects the VM uuid. 

* Thu Jan 06 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-4 
- backout 

* Thu Jan 06 2011 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-3 
- first pass 

* Wed Dec 15 2010 Kurt Hackel <kurt.hackel@oracle.com> - 1.0.1-2 
- Add init.d script for qlayer monitor. 

